Name: user-mode-linux

### zurukko.
%global _unpackaged_files_terminate_build 0

%{?!preemptible_kernel:   %global preemptible_kernel   0}
%{?!additionalciphers:    %global additionalciphers    0}
%{?!xcast6:               %global xcast6               0}

### 

%global _ipv6             1
%global _debug            0

### Version defines
%global srcversion 2.4.26
%global momorel 1
%global rel %{momorel}m
%global kversion 2.4.26
%global usagibase 2.4.26-rc1
%global usagisnapver_month 200404
%global usagisnapver_day 13
%global usagisnapver %{usagisnapver_month}%{usagisnapver_day}
%global umlver 1
%global mkinitrd_ver 3.4.33

### Constant defines
%global fileprefix kernel
%global KVERREL %{kversion}-%{PACKAGE_RELEASE}

### Constant Headers

License: GPL
URL: http://user-mode-linux.sourceforge.net/
ExclusiveArch: i386 i486 i586 i686 athlon
ExclusiveOS: Linux
BuildPreReq: sed autoconf texinfo
PreReq: modutils >= 2.4.19, sh-utils, fileutils, tar, gzip, mkinitrd >= %{mkinitrd_ver}
Autoreqprov: no

### Define-dependent headers

Version: %{srcversion}.%{umlver}
Release: %{rel}
Summary: User-Mode Linux is a safe, secure way of running Linux versions and Linux processes.
Group: Applications/System
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%global buildcc gcc
BuildRequires: gcc

%NoSource 0 ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-%{srcversion}.tar.bz2 88d7aefa03c92739cb70298a0b486e2c

Source11: module-info
Source13: rhkmvtag.c

%if %{additionalciphers}
# Source50: http://www.kernel.org/pub/linux/kernel/people/hvr/testing/patch-int-2.4.18.3.gz
Source50: http://www.jp.kernel.org/pub/linux/kernel/people/hvr/testing/patch-int-2.4.21.0.gz
# to avoid license/patent issue, this file must be NoSource.
NoSource: 50
%endif

Source130: kernel-2.4-uml.config

# Patch20: http://www.kernel.org/pub/linux/kernel/people/rml/preempt-kernel/v2.4/preempt-kernel-rml-2.4.18-5.patch

##### Filesystem

## sgi xfs
# ftp://oss.sgi.com/projects/xfs/download/patches/
#
# xfs is merged into vanilla kernel source

## smbfs
# from http://www.hojdpunkten.ac.se/054/samba/index.html
#
# smbfs is merged into vanilla kernel source

###### Networking

## IPV6
%NoPatch 40 ftp://ftp.linux-ipv6.org/pub/usagi/daily-snap/%{usagisnapver_month}/linux24-%{usagibase}-usagi-%{usagisnapver}.patch.gz 99553e569260d86afe6aaddc7d42295b
Patch41: kernel-2.4.25-usagi-compare-bool.patch

# xcast6
# http://homepage2.nifty.com/tkuro/archive/usagi-stable-4.1-xcast6.diff.gz
Patch42010: linux-2.4.23-usagi-snap-20031204-xcast6-0.1.5.2.diff

## ipvs
%NoPatch 45 http://www.ssi.bg/~ja/hidden-2.4.26-1.diff d75c835c1a739759b6c641b74445b9c3

## FreeSwan
# ftp://ftp.xs4all.nl/pub/crypto/freeswan/freeswan-1.9.1.tar.gz
Patch46: linux-2.4.16-freeswan-1.9.1.patch

## cipe
# http://sites.inka.de/~W1011/sw/cipe-1.5.2.tar.gz
Patch47: linux-2.4.13-cipe-1.5.2.patch
# http://sites.inka.de/bigred/archive/cipe-l/2002-01/msg00011.html
Patch48: cipe-1.5.2-security-fix-2002-01-07.patch
Patch49: linux-2.4.18-pre8-cipe-fix.patch

## kokorahennno nani?
Patch52: linux-2.4.13-promisc-2.patch
# [security] 
Patch53: linux-zlib_double_free-ipsec.patch
# [security] http://online.securityfocus.com/bid/5178
Patch54: linux-2.4.18-file-max-limit-DoS.patch

Patch1012: linux-2.4.16.sched.c.patch

##### From RHL
Patch1900: kondara-linux-2.4.10-pre11-changeloop.patch
# Patch1901: kondara-linux-2.4.17-changeloop-usagi.patch

Patch2000: linux-2.4.0-test7-pre4-overflow.patch
Patch2001: linux-2.4.0-nonintconfig.patch
Patch2002: kernel-2.4-string.patch
Patch2008: linux-2.2.16-useio.patch
# fix copy_from/to_user error handling

###### User Mode Linux
%NoPatch 2300 http://telia.dl.sourceforge.net/sourceforge/user-mode-linux/uml-patch-%{srcversion}-%{umlver}.bz2 e4fbac714d28cd9bcc877dfcfd5bfe57

# Patch2301: linux-2.4.18-uml-fix.patch

# Patch2304: linux-2.4.18-uml-crypto.patch
# Patch3000: arch-um-config-in.patch

Patch2305: uml-2.4.19-22-baatari-fix.patch
# Patch2307: linux-2.4.19-uml-resolve.patch

Patch3001: init-main-kernel-thread-fix.patch

################# End Patches ##################################

%description -n user-mode-linux
User-Mode Linux is a safe, secure way of running Linux versions
and Linux processes. Run buggy software, experiment with new Linux kernels
or distributions, and poke around in the internals of Linux,
all without risking your main Linux setup.

User-Mode Linux gives you a virtual machine that may have more hardware
and software virtual resources than your actual, physical computer.
Disk storage for the virtual machine is entirely contained inside a single
file on your physical machine. You can assign your virtual machine only
the hardware access you want it to have. With properly limited access,
nothing you do on the virtual machine can change or damage your real computer,
or its software. 

#############################################################
##### PREP ##################################################
#############################################################
# >>prep

%prep
%setup -q -n linux-%{srcversion}

# Bring in the Red Hat Kernel Module Version Tag program
cp %SOURCE13 .

##########
########## Patch application starts
##########


%if %{preemptible_kernel}
# % patch20 -p1
%endif

%if %{_ipv6}
%patch40 -p1
%patch41 -p1
# %%patch42001 -p1
%endif

%if %{_ipv6} && %{additionalciphers}
mkdir tmp_crypto
pushd tmp_crypto
gzip -dc %{SOURCE50} | patch -p1 > /dev/null 2>&1 || :
mv crypto/ciphers/{cipher-blowfish.c,cipher-dfc.c,cipher-idea.c,cipher-mars.c,cipher-serpent.c,cipher-twofish.c} ../crypto/ciphers/
popd
rm -rf tmp_crypto
%endif

%if %{xcast6}
%patch42010 -p1
%endif

# ipvs
%patch45 -p1

%if ! %{_ipv6}
## FreeSwan
%patch46 -p1
## cipe
%patch47 -p1
%patch48 -p1
%patch49 -p1
%endif

%patch52 -p1

%if ! %{_ipv6}
%patch53 -p1
%endif
%patch54 -p1

%if ! %{_debug}

%patch1012 -p1

%patch2000 -p1
%patch2001 -p1
%patch2002 -p1
%patch2008 -p1
%endif

%if %{_ipv6}
# % patch1901 -p1
%else
%patch1900 -p1
%endif

%patch2300 -p1
%if %{_ipv6}
# % patch2304 -p1
%endif
%patch2305 -p1

# % patch2307 -p1

# % patch3000 -p1
%patch3001 -p1

#####
##### Patching ends
#####


%if ! %{_debug}
sed -e "s/gcc/%{buildcc}/" -e "s/egcs/%{buildcc}/" Makefile > Makefile.cc
mv Makefile.cc Makefile
%endif

#backup and copy using defconfig file
cp arch/um/defconfig arch/um/defconfig.origin
cp %SOURCE130 arch/um/defconfig

find . -name "CVS" -o -name "*.orig" -o -name "*~" | xargs rm -rf

#############################################
######### build #############################
#############################################
### >>build

%build

# CPUS=1
# if [ -x %{_bindir}/getconf ]; then
#   CPUS=`getconf _NPROCESSORS_ONLN`
#   if [ "$CPUS" = "0" ]; then
#     CPUS=1
#   fi
#   CPUS=$(($CPUS * 2))
# fi

# make sure EXTRAVERSION says what we want it to say
sed "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}$1/" Makefile > Makefile.ext
mv Makefile.ext Makefile
make mrproper ARCH=um
cp %SOURCE130 .config
make oldconfig ARCH=um
make dep ARCH=um
make clean ARCH=um
make linux ARCH=um
make modules ARCH=um

%install
rm -rf %{buildroot}
make INSTALL_MOD_PATH=%{buildroot} modules_install ARCH=um
mkdir -p %{buildroot}%{_bindir}
install -m 755 linux %{buildroot}%{_bindir}/linux-%{version}-%{release}
mkdir -p %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}-%{umlver}um/include
for i in asm-um asm-generic linux math-emu net pcmcia scsi video; do
  cp -a include/$i %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}-%{umlver}um/include
done
ln -s asm-um %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}-%{umlver}um/include/asm
%ifarch %{ix86}
cp -a include/asm-i386 %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}-%{umlver}um/include
%endif
%ifarch alpha alphaev5
cp -a include/asm-alpha %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}-%{umlver}um/include
%endif
%ifarch ppc
cp -a include/asm-ppc %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}-%{umlver}um/include
cp -a include/asm-m68k %{buildroot}%{_usrsrc}/linux-%{srcversion}-%{release}-%{umlver}um/include
%endif
mkdir -p %{buildroot}%{_libdir}/uml-%{version}-%{release}
cd %{buildroot}
tar czf %{buildroot}%{_libdir}/uml-%{version}-%{release}/modules.tar.gz lib/modules/*.*.*-*um
tar czf %{buildroot}%{_libdir}/uml-%{version}-%{release}/headers.tar.gz usr/src/*
cd -

# remove
rm -rf %{buildroot}/lib
rm -rf %{buildroot}/usr/src

%clean
rm -rf %{buildroot}

%post
rm -f %{_bindir}/linux
ln -s linux-%{version}-%{release} %{_bindir}/linux

%preun
if [ "$1" = 0 ]; then
  rm -f %{_bindir}/linux
fi

%files
%defattr(-,root,root)
%{_bindir}/linux-*
%{_libdir}/uml-*

%changelog
* Fri May 14 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (2.4.26.1-1m)
- update to uml-patch-2.4.26-1
- update usagi patch to 20040413 (Patch40)
- add xcast6 patch (Patch42010)
- remove xfs patch (merged into vanilla kernel source)
- remove smbfs patch (merged into vanilla kernel source)

* Sat Mar 27 2004 Toru Hoshina <t@momonga-linux.org>
- (2.4.22.6-2m)
- revised spec for rpm 4.2.

* Thu Nov 13 2003 Hiroyuki Koga <kuma@momonga-linux.org>
- (2.4.22.6-1m)
- update to uml-patch-2.4.22-6

* Thu Nov  6 2003 Hiroyuki Koga <kuma@momonga-linux.org>
- (2.4.22.5-1m)
- update to uml-patch-2.4.22-5
- disable preempt patch (patch20)
- update xfs patch to xfs-2.4.22-all-i386 (patch30)
- update usagi patch to 20031006 (patch40)
- update ipvs patch to 1.0.10 (patch43)
- remove patch2308 (no longer required)

* Wed Nov  5 2003 zunda <zunda at freeshell.org>
- (kossori)
- defnition of BuildPreReq: moved agter defnition of Version: for speclint

* Sat Jun 28 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.4.20.6-1m)
- define momorel
- use uml-patch-2.4.20-6
- comment out patch31
- comment out patch32
- comment out patch33
- comment out patch35
- comment out patch40
- comment out patch41
- comment out patch42
- comment out patch1901
- comment out patch2307
- update Source50
- update Sourc130
- add patch3000 for resolve missing crypot/config.in problem
- cancle patch3000 by comment out Patch2304
- add patch3001 for resolve missing link kernel_thread problem

* Fri Mar 28 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (2.4.19.50-2m)
- add security patch

* Wed Feb 12 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (2.4.19.50-1m)
- uml 50
- usagi 20021129 snap

* Sun Dec  8 2002 Kazuhiko <kazuhiko@fdiary.net>
- (2.4.19.35-1m)
- usagisnapver 20021113

* Sun Nov 10 2002 Kazuhiko <kazuhiko@fdiary.net>
- (2.4.19.28-1m)

* Tue Nov  5 2002 Kazuhiko <kazuhiko@fdiary.net>
- (2.4.19.26-1m)
- support installing multiple user-mode-linux of different verisons/releases

* Mon Nov  4 2002 Kazuhiko <kazuhiko@fdiary.net>
- (2.4.19.25-1m)

* Sat Nov  2 2002 Kazuhiko <kazuhiko@fdiary.net>
-(2.4.19.24-1m)
- add tar-gzipped header files
- add more header files

* Wed Oct 30 2002 Shingo Akagaki <dora@kitty.dnsalias.org>
- (2.4.19.22-1m)
- fork from kernel.spec
